package org.omegahat.DataStructures.Matrix;

public interface Matrix extends BaseMatrix 
{
  public double[] diagonal();

  public double[] getElements(int[][] indexPairs);
  public double[] getColumn(int j);
  public double[] getRow(int i);

  public Matrix getSubMatrix(int[] rows, int[] cols);
  public Matrix getRows(int[] rows);
  public Matrix getColumns(int[] columns);

  public SquareMatrix getSubMatrix(int[] indices);

  public Matrix appendRow(double[] row);
  public Matrix appendRows(Matrix rows);
  public Matrix appendColumn(double[] col);
  public Matrix appendColumns(Matrix cols);

  public Matrix plus(Matrix B);

  public Matrix minus(Matrix B);

  public Matrix times(Matrix B);

  public double[] times(double[] y);

  public Matrix times(double s);

  public SquareMatrix outerProduct();

  public SquareMatrix crossProduct();

  public int rank();
  public double trace();

  public Matrix transpose();

  public QRDecomposition getQR();

  public SVDecomposition getSVD();

}

